chiark / gitweb /
better docs
[dgit.git] / dgit
diff --git a/dgit b/dgit
index a158eefde209e76865088d90de19ba03cf57b622..1e7be7286de63a62972f1f67b06de54d5d2f415a 100755 (executable)
--- a/dgit
+++ b/dgit
@@ -26,7 +26,6 @@ use Dpkg::Control::Hash;
 use File::Path;
 use POSIX;
 
-our $mirror = 'http://mirror.relativity.greenend.org.uk/mirror/debian-ftp/';
 our $suite = 'sid';
 our $package;
 
@@ -34,11 +33,6 @@ our $sign = 1;
 our $dryrun = 0;
 our $changesfile;
 
-our $aliothname = 'iwj@git.debian.org';
-our $aliothpath = '/git/dgit-repos';
-our $alioth_git = "git+ssh://$aliothname/$aliothpath";
-our $alioth_sshtestbodge = [$aliothname,$aliothpath];
-
 our %format_ok = map { $_=>1 } ("1.0","3.0 (native)","3.0 (quilt)");
 
 our (@git) = qw(git);
@@ -107,6 +101,7 @@ sub runcmd {
 }
 
 sub cmdoutput_errok {
+    die Dumper(\@_)." ?" if grep { !defined } @_;
     printcmd(\*DEBUG,"|",@_);
     open P, "-|", @_ or die $!;
     my $d;
@@ -136,6 +131,61 @@ sub runcmd_ordryrun {
     }
 }
 
+our %defcfg = ('dgit.default.distro' => 'debian',
+              'dgit.default.username' => '',
+              'dgit.default.ssh' => 'ssh',
+              'dgit-distro.debian.git-host' => 'git.debian.org',
+              'dgit-distro.debian.git-proto' => 'git+ssh://',
+              'dgit-distro.debian.git-path' => '/git/dgit-repos',
+              'dgit-distro.debian.git-check' => 'ssh-cmd',
+              'dgit-distro.debian.git-create' => 'ssh-cmd',
+              'dgit-distro.debian.mirror' => 'http://ftp.debian.org/debian/');
+
+sub cfg {
+    foreach my $c (@_) {
+       my $v = cmdoutput_errok(@git, qw(config --), $c);
+       if ($?==0) {
+           chomp $v;
+           return $v;
+       } elsif ($?!=256) {
+           die "$c $?";
+       }
+       my $dv = $defcfg{$c};
+       return $dv if defined $dv;
+    }
+    return undef;
+}
+
+sub access_distro () {
+    return cfg("dgit-suite.$suite.distro",
+              "dgit.default.distro");
+}
+
+sub access_cfg ($) {
+    my ($key) = @_;
+    my $distro = access_distro();
+    my $value = cfg("dgit-distro.$distro.$key",
+                   "dgit.default.$key");
+    return $value;
+}
+
+sub access_gituserhost () {
+    my $user = access_cfg('git-user');
+    my $host = access_cfg('git-host');
+    return defined($user) && length($user) ? "$user\@$host" : $host;
+}
+
+sub access_giturl () {
+    my $url = access_cfg('git-url');
+    if (!defined $url) {
+       $url =
+           access_cfg('git-proto').
+           access_gituserhost().
+           access_cfg('git-path');
+    }
+    return "$url/$package.git";
+}             
+
 sub parsecontrol {
     my $c = Dpkg::Control::Hash->new();
     $c->load(@_) or return undef;
@@ -153,8 +203,14 @@ sub parsechangelog {
 
 our $rmad;
 
-sub askmadison () {
-    $rmad ||= cmdoutput qw(rmadison -asource),"-s$suite",$package;
+sub archive_query () {
+    my $query = access_cfg('archive-query');
+    $query ||= "madison:".access_distro();
+    $query =~ s/^(\w+):// or die "$query ?";
+    my $proto = $1;
+    my $url = $'; #';
+    die unless $proto eq 'madison';
+    $rmad ||= cmdoutput qw(rmadison -asource),"-s$suite","-u$url",$package;
     $rmad =~ m/^ \s*( [^ \t|]+ )\s* \|
                  \s*( [^ \t|]+ )\s* \|
                  \s*( [^ \t|]+ )\s* \|
@@ -167,18 +223,19 @@ sub askmadison () {
        $suite = $3;
     }
     $4 eq 'source' or die "$rmad ?";
-    return $vsn;
+    my $prefix = substr($package, 0, $package =~ m/^l/ ? 4 : 1);
+    my $subpath = "/pool/main/$prefix/$package/${package}_$vsn.dsc";
+    return ($vsn,$subpath);
 }
 
 sub canonicalise_suite () {
-    askmadison();
+    archive_query();
 }
 
 sub get_archive_dsc () {
-    my $vsn = askmadison();
+    my ($vsn,$subpath) = archive_query();
     # fixme madison does not show us the component
-    my $prefix = substr($package, 0, $package =~ m/^l/ ? 4 : 1);
-    $dscurl = "$mirror/pool/main/$prefix/$package/${package}_$vsn.dsc";
+    $dscurl = access_cfg('mirror').$subpath;
     $dscdata = url_get($dscurl);
     my $dscfh = new IO::File \$dscdata, '<' or die $!;
     print DEBUG Dumper($dscdata);
@@ -191,18 +248,32 @@ sub get_archive_dsc () {
 
 sub check_for_git () {
     # returns 0 or 1
-    my $cmd= 
-       "ssh $alioth_sshtestbodge->[0] '".
-       " set -e; cd $alioth_sshtestbodge->[1];".
-       " if test -d $package.git; then echo 1; else echo 0; fi".
-       "'";
-    print DEBUG "$cmd\n";
-    open P, "$cmd |" or die $!;
-    $!=0; $?=0;
-    my $r = <P>; close P;
-    print DEBUG ">$r<\n";
-    die "$r $! $?" unless $r =~ m/^[01]$/;
-    return $r+0;
+    my $how = access_cfg('git-check');
+    if ($how eq 'ssh-cmd') {
+       my $r= cmdoutput
+           (access_cfg('ssh'),access_gituserhost(),
+            " set -e; cd ".access_cfg('git-path').";".
+            " if test -d $package.git; then echo 1; else echo 0; fi");
+       print DEBUG ">$r<\n";
+       die "$r $! $?" unless $r =~ m/^[01]$/;
+       return $r+0;
+    } else {
+       die "unknown git-check $how ?";
+    }
+}
+
+sub create_remote_git_repo () {
+    my $how = access_cfg('git-create');
+    if ($how eq 'ssh-cmd') {
+       runcmd_ordryrun
+           (access_cfg('ssh'),access_gituserhost(),
+            "set -e; cd ".access_cfg('git-path').";".
+            " mkdir -p $package.git;".
+            " cd $package.git;".
+            " if ! test -d objects; then git init --bare; fi");
+    } else {
+       die "unknown git-create $how ?";
+    }
 }
 
 our ($dsc_hash,$upload_hash);
@@ -347,7 +418,7 @@ sub is_fast_fwd ($$) {
 
 sub git_fetch_us () {
     die "cannot dry run with fetch" if $dryrun;
-    runcmd @git, qw(fetch),$remotename,fetchspec();
+    runcmd @git, qw(fetch),access_giturl(),fetchspec();
 }
 
 sub fetch_from_archive () {
@@ -365,10 +436,13 @@ sub fetch_from_archive () {
 
     $!=0; $upload_hash =
        cmdoutput_errok @git, qw(show-ref --heads), lrref();
-    die $! if $!;
-    die $? unless ($?==0 && chomp $upload_hash) 
-       or ($?==256 && !length $upload_hash);
-    $upload_hash ||= '';
+    if ($?==0) {
+       die unless chomp $upload_hash;
+    } elsif ($?==256) {
+       $upload_hash = '';
+    } else {
+       die $?;
+    }
     my $hash;
     if (defined $dsc_hash) {
        die "missing git history even though dsc has hash"
@@ -403,7 +477,7 @@ sub clone ($) {
     open H, "> .git/HEAD" or die $!;
     print H "ref: ".lref()."\n" or die $!;
     close H or die $!;
-    runcmd @git, qw(remote add), 'origin', "$alioth_git/$package.git";
+    runcmd @git, qw(remote add), 'origin', access_giturl();
     if (check_for_git()) {
        print "fetching existing git history\n";
        git_fetch_us();
@@ -432,7 +506,6 @@ sub pull () {
 sub dopush () {
     runcmd @git, qw(diff --quiet HEAD);
     my $clogp = parsechangelog();
-    die if defined $package;
     $package = $clogp->{Source};
     my $dscfn = "${package}_$clogp->{Version}.dsc";
     stat "../$dscfn" or die "$dscfn $!";
@@ -465,13 +538,9 @@ sub dopush () {
     }
     my $tag = debiantag($dsc->{Version});
     if (!check_for_git()) {
-       runcmd_ordryrun qw(ssh),$alioth_sshtestbodge->[0],
-       "set -e; cd $alioth_sshtestbodge->[1];".
-           " mkdir -p $package.git;".
-           " cd $package.git;".
-           " if ! test -d objects; then git init --bare; fi";
+       create_remote_git_repo();
     }
-    runcmd_ordryrun @git, qw(push),$remotename,"HEAD:".rrref();
+    runcmd_ordryrun @git, qw(push),access_giturl(),"HEAD:".rrref();
     if ($sign) {
        my @tag_cmd = (@git, qw(tag -s -m),
                       "Release $dsc->{Version} for $suite [dgit]");
@@ -483,8 +552,10 @@ sub dopush () {
        push @debsign_cmd, $changesfile;
        runcmd_ordryrun @debsign_cmd;
     }
-    runcmd_ordryrun @git, qw(push),$remotename,"refs/tags/$tag";
-    runcmd_ordryrun @dput, $changesfile;
+    runcmd_ordryrun @git, qw(push),access_giturl(),"refs/tags/$tag";
+    my $host = access_cfg('upload-host');
+    my @hostarg = defined($host) ? ($host,) : ();
+    runcmd_ordryrun @dput, @hostarg, $changesfile;
 }
 
 sub cmd_clone {
@@ -596,7 +667,7 @@ sub parseopts () {
                } elsif (s/^-D/-/) {
                    open DEBUG, ">&STDERR" or die $!;
                } elsif (s/^-c(.*=.*)//s) {
-                   push @git, $1;
+                   push @git, '-c', $1;
                } elsif (s/^-C(.*)//s) {
                    $changesfile = $1;
                } elsif (s/^-k(.*)//s) {